<?php
namespace Teknisa\OPL\Modules\Cadastros\Controllers;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\OPL\Modules\Cadastros\Services\PrioridadeSeparacaoOLService;

class PrioridadeSeparacaoOLController extends \Teknisa\GER\Controllers\TeknisaCrud 
{

	protected $crudService;
    protected $dataSourceManager;
    protected $entityManager;
    
    public function __construct($crudService, $parameterBag, $dataSourceManager, EntityManager $entityManager, PrioridadeSeparacaoOLService $service)
    {
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->dataSourceManager = $dataSourceManager;
        $this->entityManager = $entityManager;
        $this->service = $service;
	}
	
	public function moveSelectedRowsToPrioridade(DTO\Request\DataSet $request, DTO\Response $response)
	{
	    $unidade = $request->getDataSet()->getRows();
	    foreach($unidade as $var){
	        $var['NRPRIORIZAOLFILDEST'] = $this->service->NovoCodigo('PRIORIZAOLFILDEST'.$var['CDFILIOPELOG']);
	        $var['__is_new'] = true;
	    }

	    $this->saveEntrega($unidade);
	    $response->addDataSet(new DataSet("resposta", $unidade));
	}
	
	protected function saveEntrega($unidade)
	{
        $this->dataSourceName = "priorizaolfildest";
        $this->crudService->save($this->dataSourceName, $unidade);
    }
    
    public function updateRegisterOnPrioridade(DTO\Request\DataSet $request, DTO\Response $response)
    {
	    $unidade = $request->getDataSet()->getRows();
	    $this->saveEntrega($unidade);
	    $response->addDataSet(new DataSet("resposta", $unidade));
	}
}    